<?php

namespace App\Models\Cloudflare;

use App\Entities\Cloudflare\ZoneEntity;
use App\Entities\Cloudflare\RecordEntity;
use App\Models\CommonModel;

class RecordModel extends CommonModel
{
    const TABLE  = "cloudflarerecord";
    const PK     = "uid";
    const TITLE  = "host";
    const PARENT = "zone_uid";
    protected $table = self::TABLE;
    protected $primaryKey = self::PK;
    protected $useAutoIncrement = false;
    protected $returnType = RecordEntity::class; //object,array,entity명::class
    protected $allowedFields = [self::PK, self::PARENT, self::TITLE, 'type', 'content', 'ttl', 'proxiable', 'proxied', 'fixed', 'locked', 'updated_at', 'crated_at'];
    protected $useTimestamps = true;

    public function __construct()
    {
        parent::__construct();
    }
    public function getTitleField(): string
    {
        return self::TITLE;
    }
    public function getFieldRule(string $field, array $rules): array
    {
        switch ($field) {
            case self::PARENT:
                $rules[$field] = "required|regex_match[/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}/]";;
                break;
            case self::TITLE:
            case "content":
                $rules[$field] = "required|trim|string";
                break;
            case "type":
                $rules[$field] = "required|in_list[A,AAA,CNAME,MX,NS,PTR,SPF,TXT,SRV,INFO]";
                break;
            case "ttl":
                $rules[$field] = "if_exist|numeric";
                break;
            case "proxiable":
            case "proxied":
            case "fixed":
            case "locked":
                $rules[$field] = "if_exist|in_list[on,off]";
                break;
            default:
                $rules = parent::getFieldRule($field, $rules);
                break;
        }
        return $rules;
    }
    public function getFormFieldInputOption(string $field, array $options = []): array
    {
        switch ($field) {
            default:
                $this->orderBy(self::TITLE, 'asc');
                $options = parent::getFormFieldInputOption($field, $options);
                break;
        }
        return $options;
    }
    public function getEntityByPK(int $uid): null|RecordEntity
    {
        $this->where(self::PK, $uid);
        return $this->getEntity();
    }
    public function getEntityByID(string $id): null|RecordEntity
    {
        $this->where(self::TITLE, $id);
        return $this->getEntity();
    }

    //create용
    public function create(array $formDatas = []): RecordEntity
    {
        return $this->create_process(new RecordEntity(), $formDatas);
    }
    //modify용
    public function modify(RecordEntity $entity, array $formDatas): RecordEntity
    {
        return $this->modify_process($entity, $formDatas);
    }
    public function getEntitysByParent(ZoneEntity $zone_entity)
    {
        $this->where(self::PARENT, $zone_entity->getPK());
        return $this->getEntitys();
    }
    //도메인이 이미 존재하는지 체크
    public function isUniqueHost($zone_uid, string $host, string $content): bool
    {
        $this->where(self::PARENT, $zone_uid);
        $this->where('host', $host);
        $this->where('content', $content);
        return is_null($this->first()) ? true : false;
    }
    //CDN값 수정 못하는 고정 Record 처리
    public function setFixedCDNRecord(array $hosts)
    {
        if (count($hosts)) {
            $this->whereIn('host', $hosts)->set(['fixed' => 'on'])->update();
            log_message("notice", "-----set fixed Records " . implode(",", $hosts) . "처리 완료-----");
        }
    }

    //List 검색용
    public function setList_WordFilter(string $word, $field = null): void
    {
        parent::setList_WordFilter($word, $field);
        $this->orLike('content', $word, 'both');
    }
    public function setList_OrderBy(string $order)
    {
        //Join을 해서 도메인부터 Sorting하기위함
        $this->join('cloudflarezone', "cloudflarezone.uid=cloudflarerecord.zone_uid");
        $this->orderBy("cloudflare.domain ASC");
        parent::setList_OrderBy($order);
    }
}
